#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <constants.h>
#include <dio96.h>
#include <structdef.h>
#include <global_variables.h>
#include <function_declarations.h>

void parse_initialization_textfile(char *, short *, short *);

int main(int argc, char *argv[])
{
	int i;

	short chip_init_array[112];	
	short bit_init_array[96];		
	
	dio_variable_struct *dio_variables_ptr;
        dio_variables_ptr = &dio_variables;

	parse_initialization_textfile(argv[1], chip_init_array, bit_init_array);
 	// HARDWARE SPECIFIC INIT ROUTINES (DIO)

        i = open_dio_board(dio_variables_ptr);
	printf("DIO board open ...complete !\n");

	i = chip_init(dio_variables_ptr, chip_init_array);
	printf("DIO chip init ... complete !\n");

	i = populate_ioctls(dio_variables_ptr);
	printf("DIO ioctl defs ... complete !\n");

	i = initialize_bits(dio_variables_ptr, bit_init_array);
	printf("DIO bit initialization ... complete !\n");

	i = close_dio_board(dio_variables_ptr);
	//printf("DIO board closing ...\n");

	exit(0);
}


void parse_initialization_textfile(char *textfile, short *chip_init_array, short *bit_init_array)
{
        int i, j, k;
        int string_len, equal_sign_position;
	char dio_config_array[55];
	char dio_config_array_2[20];
	short dio_initialization_array[112];
		
	FILE *config_file;
	
	config_file=fopen(textfile, "r");
	k = 0;
	while((fgets(dio_config_array, 50, config_file) != NULL)){
 		string_len = strlen(dio_config_array) - 1;
 		dio_config_array[string_len] = 0; // strip off CR/LF at end of line
		for (j = 0; j <= string_len; j++)
			if (dio_config_array[j] == 0x3D) equal_sign_position = j;		
		for (i = 0, j = (equal_sign_position + 1); j <= string_len; i++, j++)
			dio_config_array_2[i] = dio_config_array[j];
		if (!strcmp(dio_config_array_2, "INPUT")) dio_initialization_array[k] = 1;
		if (!strcmp(dio_config_array_2, "OUTPUT")) dio_initialization_array[k] = 0;
		if (!strcmp(dio_config_array_2, "OFF")) dio_initialization_array[k] = 0;
		if (!strcmp(dio_config_array_2, "ON")) dio_initialization_array[k] = 1;
		k++;
						
	}	
	fclose(config_file);
	for (i = 0; i <=15; i++){
		chip_init_array[i] = dio_initialization_array[i];
		//printf("chip_init %i: %i\n", i, chip_init_array[i]);
		}
	for (i = 0; i <= 95; i++){
		bit_init_array[i] = dio_initialization_array[i + 16];
		//printf("bit_init %i: %i\n", i, bit_init_array[i]);
		}
	//exit(0);
}
